--[[
AddConfig

Specialization for extended configurations and register new configurations.

Author:		Ifko[nator]
Datum:		04.07.2018

Version:	v3.4

History:	v1.0 @ 28.02.2017 - initial implementation - added possibility to change capacity via configuration
			-------------------------------------------------------------------------------------------------------------------------------------------------------------
			v2.0 @ 25.03.2017 - added possibility to change rim and axis color via configuration
			-------------------------------------------------------------------------------------------------------------------------------------------------------------
			v3.0 @ 21.07.2017 - added possibility to change fillable fill types and cutable fruit types via configuration
			-------------------------------------------------------------------------------------------------------------------------------------------------------------
			v3.1 @ 13.12.2017 - a little bit code optimation
			-------------------------------------------------------------------------------------------------------------------------------------------------------------
			v3.2 @ 31.12.2017 - increased the limit from 64 to 134.217.728 configurations, i hope thats enough now!
			-------------------------------------------------------------------------------------------------------------------------------------------------------------
			v3.3 @ 04.03.2018 - the capacity value from the fillUnit in the xml file will now set to the new capacity to avoid fill the fill volume too fast or too slow
			-------------------------------------------------------------------------------------------------------------------------------------------------------------
			V3.4 @ 04.07.2018 - added possibility to change the mass and possiblity to deactivate the fillable Spezi of an vehicle via configuration
]]

AddConfig={}AddConfig.currentModDirectory=g_currentModDirectory;AddConfig.debugPriority=0;local function a(b,c,d)local e="::ERROR:: "if c then e="::WARNING:: "elseif d then e="::INFO:: "end;print(e.."from the AddConfig.lua: "..tostring(b))end;local function f(g,h,i)if AddConfig.debugPriority>=h then local e=""if i then e="::DEBUG:: from the AddConfig.lua: "end;print(e..tostring(g))end end;if ConfigurationUtil.sendNumBits<27 then ConfigurationUtil.sendNumBits=27;a("Set max number of configurations to "..g_i18n:formatNumber(2^ConfigurationUtil.sendNumBits),false,true)end;function AddConfig.prerequisitesPresent(j)return true end;function AddConfig:load(k)self.applyCustomDesing=Utils.overwrittenFunction(self.applyDesign,AddConfig.applyCustomDesing)local l=loadXMLFile("modDesc",AddConfig.currentModDirectory.."modDesc.xml")AddConfig.debugPriority=Utils.getNoNil(getXMLFloat(l,"vehicle.newConfigurations#debugPriority"),AddConfig.debugPriority)local m=0;while true do local n="modDesc.newConfigurations.newConfiguration("..tostring(m)..")"if not hasXMLProperty(l,n)then break end;local o=Utils.getNoNil(getXMLBool(l,n.."#isColorConfig"),false)local p=Utils.getNoNil(getXMLString(l,n.."#configName"),"")if p~=""then if self.configurations[p]~=nil then f("Found configuration '"..p.."' in vehicle '"..self.configFileName.."'.",1,true)if o then self:setColor(self.xmlFile,p,self.configurations[p])f("Set color on vehichle '"..self.configFileName.."'.",1,true)else self:applyCustomDesing(self.xmlFile,self.configurations[p],p)f("Apply custom desing on vehichle '"..self.configFileName.."'.",1,true)end end else a("Missing the name for the new configuration in '"..n.."'! Stopping adding this config now!",false,false)end;m=m+1 end;delete(l)end;function AddConfig:preLoad(k)local l=loadXMLFile("modDesc",AddConfig.currentModDirectory.."modDesc.xml")local m=0;while true do local n="modDesc.newConfigurations.newConfiguration("..tostring(m)..")"if not hasXMLProperty(l,n)then break end;local p=Utils.getNoNil(getXMLString(l,n.."#configName"),"")if p~=""then if self.configurations[p]~=nil then local n=string.format("vehicle."..p.."Configurations."..p.."Configuration(%d)",self.configurations[p]-1)local q=getXMLFloat(self.xmlFile,n.."#capacity")local r=Utils.getNoNil(getXMLBool(self.xmlFile,n.."#isFillable"),true)local s=getXMLString(self.xmlFile,n.."#fillUnitIndex")local t=getXMLString(self.xmlFile,n.."#fillSoundFile")if s~=nil then local u=Utils.splitString(" ",s)local v=Utils.splitString(" ",Utils.getNoNil(getXMLString(self.xmlFile,n.."#volumeIndex"),"0"))if#u==#v then for w,x in pairs(v)do for w,s in pairs(u)do if hasXMLProperty(self.xmlFile,"vehicle.fillVolumes.volumes.volume("..x..")")then setXMLString(self.xmlFile,"vehicle.fillVolumes.volumes.volume("..x..")#index",s)else break end end end else a('Found "'..#u..'" fillUnitIndexes and "'..#v..'" volumeIndexes! They must have the same count! The fill volume was not changed for this vehicle!',false,false)end end;if q~=nil then if q>0 then local y=0;while true do local z="vehicle.fillUnits.fillUnit("..tostring(y)..")"if not hasXMLProperty(self.xmlFile,z)then break end;y=y+1 end;for A=1,y do setXMLFloat(self.xmlFile,"vehicle.fillUnits.fillUnit("..A-1 ..")#capacity",q/y)end else a('The value from capacity must be greater as 0! To deactivate the fillable for this vehicle, use isFillable="false" instead! The capacity was not changed for this vehicle!',false,false)end end;if not r then setXMLBool(self.xmlFile,"vehicle.allowFillFromAir#value",false)end;if t~=nil then setXMLString(self.xmlFile,"vehicle.fillSound#file",t)end end end;m=m+1 end;delete(l)end;function AddConfig:applyCustomDesing(B,C,D,p)local n=string.format("vehicle."..p.."Configurations."..p.."Configuration(%d)",D-1)if not hasXMLProperty(C,n)then a("Invalid '"..p.."s' configuration ("..D..")",true,false)return end;local E={}local F=getXMLString(self.xmlFile,n.."#fruitTypeCategories")local G=getXMLString(self.xmlFile,n.."#fruitTypes")local H=false;if F~=nil and G==nil then E=FruitUtil.getFruitTypeByCategoryName(F)elseif F==nil and G~=nil then E=FruitUtil.getFruitTypesByNames(G)end;if E~=nil then for w,I in pairs(E)do if not H then self.fruitTypes={}H=true end;local J=FillUtil.fillTypeIntToName[I]if J~=nil then self.fruitTypes[I]=true;f("Insert fruit type '"..J.."' successfully to '"..self.configFileName.."'.",1,true)end end end;local K={}local L=getXMLString(C,n.."#fillTypeCategories")local M=getXMLString(C,n.."#fillTypes")local N=false;if L~=nil and M==nil then K=FillUtil.getFillTypeByCategoryName(L)elseif L==nil and M~=nil then K=FillUtil.getFillTypesByNames(M)end;if K~=nil then for w,O in pairs(K)do for w,A in pairs(self.fillUnits)do if not N then A.fillTypes={}N=true end;local P=FillUtil.fillTypeIntToName[O]if P~=nil then A.fillTypes[O]=true;f("Insert fill type '"..P.."' successfully to '"..self.configFileName.."'.",1,true)end end end end;local r=Utils.getNoNil(getXMLBool(C,n.."#isFillable"),true)if not r then for w,A in pairs(self.fillUnits)do A.showOnHud=showFillLevelOnHud;A.fillTypes={}f("Decativated fillable successfully in '"..self.configFileName.."'.",1,true)end end;local Q=getXMLFloat(C,n.."#mass")if Q~=nil then setMass(self.rootNode,getMass(self.rootNode)+Q)f("Change mass to: "..getMass(self.rootNode).."' (old mass "..getMass(self.rootNode)-Q..") successfully in '"..self.configFileName.."'.",1,true)end;local R=getXMLString(C,n.."#axisColor")local S=getXMLString(C,n.."#rimColor")for w,T in pairs(self.wheels)do if R~=nil then self.axisColor=Vehicle.getColorFromString(R)if T.wheelHub~=nil then local U,V,W,X=unpack(self.axisColor)setShaderParameter(T.wheelHub,"colorScale",U,V,W,X,false)f("Change axis color to: "..R.."' successfully in '"..self.configFileName.."'.",1,true)end end;if S~=nil then self.rimColor=Vehicle.getColorFromString(S)local U,V,W,X=unpack(self.rimColor)if T.wheelOuterRim~=nil then setShaderParameter(T.wheelOuterRim,"colorScale",U,V,W,X,false)f("Change outer rim color to: "..S.."' successfully in '"..self.configFileName.."'.",1,true)end;if T.wheelInnerRim~=nil then setShaderParameter(T.wheelInnerRim,"colorScale",U,V,W,X,false)f("Change inner rim color to: "..S.."' successfully in '"..self.configFileName.."'.",1,true)end end end;local Y=0;while true do local Z=string.format(n..".material(%d)",Y)if not hasXMLProperty(C,Z)then break end;local _=Utils.indexToObject(self.components,getXMLString(C,Z.."#node"))local a0=Utils.indexToObject(self.components,getXMLString(C,Z.."#refNode"))if _~=nil and a0~=nil then local a1=getMaterial(_,0)local a2=getMaterial(a0,0)for w,a3 in pairs(self.components)do self:replaceMaterialRec(a3.node,a1,a2)f("Change material successfully in '"..self.configFileName.."'.",1,true)end end;Y=Y+1 end;ObjectChangeUtil.updateObjectChanges(self.xmlFile,"vehicle."..p.."Configurations."..p.."Configuration",D,self.components,self)end;function AddConfig:delete()end;function AddConfig:mouseEvent(a4,a5,a6,a7,a8)end;function AddConfig:keyEvent(a9,aa,ab,a6)end;function AddConfig:update(ac)end;function AddConfig:draw()end;local l=loadXMLFile("modDesc",AddConfig.currentModDirectory.."modDesc.xml")local m=0;while true do local n="modDesc.newConfigurations.newConfiguration("..tostring(m)..")"if not hasXMLProperty(l,n)then break end;local o=Utils.getNoNil(getXMLBool(l,n.."#isColorConfig"),false)local p=Utils.getNoNil(getXMLString(l,n.."#configName"),"")if p~=""then if ConfigurationUtil.configurations[p]==nil then if o then ConfigurationUtil.registerConfigurationType(p,g_i18n:getText("configuration_"..p),nil,Vehicle.getConfigColorSingleItemLoad,Vehicle.getConfigColorPostLoad,ConfigurationUtil.SELECTOR_COLOR)f("Register color configuration '"..p.."' successfully.",1,true)else ConfigurationUtil.registerConfigurationType(p,g_i18n:getText("configuration_"..p),nil,nil,nil,ConfigurationUtil.SELECTOR_MULTIOPTION)f("Register desing configuration '"..p.."' successfully.",1,true)end end else a("Missing the name for the new Config in '"..n.."'! Stopping register this config now!",false,false)end;m=m+1 end