--[[
ExtendedTruckFunctions

Script to animate some indoor parts in a vehicle

@Author:     Ifko[nator]
@Date:       22.07.2018

@Version:    1.5

@History:    v1.0 @ 28.12.2017 - initial release in FS 17
			 v1.5 @ 22.07.2018 - added support for animation 'setRainWipperToStart'
]]

ExtendedTruckFunctions={}function ExtendedTruckFunctions.prerequisitesPresent(a)return SpecializationUtil.hasSpecialization(AnimatedVehicle,a)end;local b=0;local function c(d,e)local f="Error "if e then f="Warning "end;print(f.."from the ExtendedTruckFunctions.lua: "..tostring(d))end;local function g(h,i,j)if b>=i then local f=""if j then f="Debug: from the ExtendedTruckFunctions.lua: "end;print(f..tostring(h))end end;function ExtendedTruckFunctions:preLoad(k)self.setLightsTypesMask=Utils.prependedFunction(self.setLightsTypesMask,ExtendedTruckFunctions.setLightsTypesMask)end;function ExtendedTruckFunctions:load(k)self.extendedTruckFunctions={}local l=0;g("",1,false)g("-----------------------------------------------Debug from the ExtendedTruckFunctions.lua Start------------------------------------------------",1,false)g("",1,false)g("-----------------------------------------------Debug from the needles Start------------------------------------------------",1,false)self.extendedTruckFunctions.needles={}while true do local m="vehicle.extendedTruckFunctions.needle("..tostring(l)..")"if not hasXMLProperty(self.xmlFile,m)then g("-----------------------------------------------Debug from the needles End------------------------------------------------",1,false)g("",1,false)break end;local n=getXMLString(self.xmlFile,m.."#name")if n~=nil and n~=""then local o={}o.name=n;o[o.name]={}o[o.name].node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,m.."#node"))o[o.name].maxRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,m.."#maxRot"),"0 0 30"),3)o[o.name].needleTime=0;o[o.name].increaseFactor=Utils.getNoNil(getXMLString(self.xmlFile,m.."#increaseFactor"),1)/100000;o[o.name].decreaseFactor=Utils.getNoNil(getXMLString(self.xmlFile,m.."#decreaseFactor"),2.5)/100000;o[o.name].addMax=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,m.."#addMax"),"0 0 50"),3)o[o.name].addMin=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,m.."#addMin"),"0 0 5"),3)o[o.name].addTime={0,0,0}g("Load needle '"..o.name.."' number '"..l+1 .."' successfully.",1,true)table.insert(self.extendedTruckFunctions.needles,o)else c("Missing the 'name' attribute for the needle number '"..l+1 .."'! The script will skip this needle now!",false)end;l=l+1 end;local p=0;g("-----------------------------------------------Debug from the display numbers Start------------------------------------------------",1,false)self.extendedTruckFunctions.displayNumbers={}while true do local q="vehicle.extendedTruckFunctions.displayNumber("..tostring(p)..")"if not hasXMLProperty(self.xmlFile,q)then g("-----------------------------------------------Debug from the display numbers End------------------------------------------------",1,false)g("",1,false)break end;local r=getXMLString(self.xmlFile,q.."#node")local s=getXMLString(self.xmlFile,q.."#refNode")if r~=nil and r~=""then if s~=nil and s~=""then local number={}number.node=Utils.indexToObject(self.components,r)number.refNode=Utils.indexToObject(self.components,s)number.oldMaterial=getMaterial(number.node,0)number.newMaterial=getMaterial(number.refNode,0)g("Load display number "..p+1 .." successfully.",1,true)table.insert(self.extendedTruckFunctions.displayNumbers,number)else c("Missing the 'refNode' attribute for the display number '"..number+1 .."'! The script will skip this display number now!",false)end else c("Missing the 'node' attribute for the display number '"..number+1 .."'! The script will skip this display number now!",false)end;p=p+1 end;self.extendedTruckFunctions.oldTurnLightStateLeft=Lights.TURNLIGHT_OFF;self.extendedTruckFunctions.oldTurnLightStateRight=Lights.TURNLIGHT_OFF;self.getIsRainTypeActive=ExtendedTruckFunctions.getIsRainTypeActive;self.setRainWipper=ExtendedTruckFunctions.setRainWipper;self.extendedTruckFunctions.rainWipperIsActive=false;self.extendedTruckFunctions.rainWipperIsOnStart=true;if k~=nil and not k.resetVehicles then self.extendedTruckFunctions.rainWipperIsActive=Utils.getNoNil(getXMLBool(k.xmlFile,k.key.."#rainWipperIsActive"),self.extendedTruckFunctions.rainWipperIsActive)g("-----------------------------------------------Debug from the rain wipper Start------------------------------------------------",2,false)g("Set rain to active = "..tostring(self.extendedTruckFunctions.rainWipperIsActive),2,true)g("-----------------------------------------------Debug from the rain wipper End------------------------------------------------",2,false)g("",2,false)end;g("-----------------------------------------------Debug from the ExtendedTruckFunctions.lua End------------------------------------------------",1,false)g("",1,false)self:setRainWipper(self.extendedTruckFunctions.rainWipperIsActive,false)self.extendedTruckFunctions.wonderTreeNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.extendedTruckFunctions.wondertree#node"))self.extendedTruckFunctions.wonderTreeRefNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.extendedTruckFunctions.wondertree#refNode"))if self.extendedTruckFunctions.wonderTreeNode~=nil and self.extendedTruckFunctions.wonderTreeRefNode~=nil then self.extendedTruckFunctions.wonderTreeNodeDefaultMaterial=getMaterial(self.extendedTruckFunctions.wonderTreeNode,0)self.extendedTruckFunctions.wonderTreeNodeNewMaterial=getMaterial(self.extendedTruckFunctions.wonderTreeRefNode,0)end;self.extendedTruckFunctions.controllerName=""end;function ExtendedTruckFunctions:update(t)if self.extendedTruckFunctions.oldTurnLightStateLeft~=self.turnLightState and self.turnLightState~=Lights.TURNLIGHT_RIGHT and self.animations["setTurnLightSwitchLeft"]~=nil then if self.turnLightState==Lights.TURNLIGHT_LEFT then self:playAnimation("setTurnLightSwitchLeft",1,nil,true)else self:playAnimation("setTurnLightSwitchLeft",-1,nil,true)end;self.extendedTruckFunctions.oldTurnLightStateLeft=self.turnLightState end;if self.extendedTruckFunctions.oldTurnLightStateRight~=self.turnLightState and self.turnLightState~=Lights.TURNLIGHT_LEFT and self.animations["setTurnLightSwitchRight"]~=nil then if self.turnLightState==Lights.TURNLIGHT_RIGHT then self:playAnimation("setTurnLightSwitchRight",1,nil,true)else self:playAnimation("setTurnLightSwitchRight",-1,nil,true)end;self.extendedTruckFunctions.oldTurnLightStateRight=self.turnLightState end;if self.timeHud~=nil then for u,v in ipairs(self.timeHud)do if v.numbers~=nil then end end end;if not self.isMotorStarted then for u,o in pairs(self.extendedTruckFunctions.needles)do if o.name=="battery"or o.name=="amps"then o[o.name].addTime[1]=math.random(o[o.name].addMin[1],o[o.name].addMax[1])o[o.name].addTime[2]=math.random(o[o.name].addMin[2],o[o.name].addMax[2])o[o.name].addTime[3]=math.random(o[o.name].addMin[3],o[o.name].addMax[3])end end end;if self.isMotorStarted then setTextAlignment(RenderText.ALIGN_CENTER)for u,o in pairs(self.extendedTruckFunctions.needles)do if o[o.name].node~=nil then o[o.name].needleTime=math.min(o[o.name].needleTime+o[o.name].increaseFactor*t,1)local w=o[o.name].needleTime;local x=true;if o.name=="airPressure"and self.brakeCompressor~=nil then w=self.brakeCompressor.fillLevel/self.brakeCompressor.capacity elseif o.name=="turboBoost"then w=self.axisForward;x=self.axisForward<0 end;local y=o[o.name].maxRot[1]*w+o[o.name].addTime[1]local z=o[o.name].maxRot[2]*w+o[o.name].addTime[2]local A=o[o.name].maxRot[3]*w+o[o.name].addTime[3]if o.name=="turboBoost"then local B=true;if self.driveControl~=nil then if self.dCcheckModule~=nil and self:dCcheckModule("shuttle")~=nil and self.driveControl.shuttle.isActive then B=self.driveControl.shuttle.direction>0 else x=not self.brakeLightsVisibility end else x=not self.brakeLightsVisibility end;if B then if self.axisForward<=0 then y=-y;z=-z;A=-A end else x=self.axisForward>0 end end;if x then setRotation(o[o.name].node,math.rad(y),math.rad(z),math.rad(A))end end end;if self:getIsRainTypeActive()and self.animations["playRainWipper"]~=nil then if self:getIsActiveForInput()then if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2)then self:setRainWipper(not self.extendedTruckFunctions.rainWipperIsActive,false)if self.animations["setRainWipperSwitch"]~=nil then if self.extendedTruckFunctions.rainWipperIsActive then self:playAnimation("setRainWipperSwitch",1,nil,true)else self:playAnimation("setRainWipperSwitch",-1,nil,true)end end end end;if self.extendedTruckFunctions.rainWipperIsActive then self:playAnimation("playRainWipper",1,nil,true)self.extendedTruckFunctions.rainWipperIsOnStart=false else if not self:getIsAnimationPlaying("playRainWipper")and self.animations["setRainWipperToStart"]~=nil and not self.extendedTruckFunctions.rainWipperIsOnStart then self:playAnimation("setRainWipperToStart",1,nil,true)self.extendedTruckFunctions.rainWipperIsOnStart=true end end end else for l,o in pairs(self.extendedTruckFunctions.needles)do if o[o.name].node~=nil then o[o.name].needleTime=math.max(o[o.name].needleTime-o[o.name].decreaseFactor*t,0)setRotation(o[o.name].node,0,0,0)end end end;if self.extendedTruckFunctions.wonderTreeNode~=nil and self.extendedTruckFunctions.wonderTreeRefNode~=nil and self.extendedTruckFunctions.controllerName~=self.controllerName then if self.controllerName=="SnookieSnu"then self:replaceMaterialRec(self.extendedTruckFunctions.wonderTreeNode,self.extendedTruckFunctions.wonderTreeNodeDefaultMaterial,self.extendedTruckFunctions.wonderTreeNodeNewMaterial)else self:replaceMaterialRec(self.extendedTruckFunctions.wonderTreeNode,self.extendedTruckFunctions.wonderTreeNodeNewMaterial,self.extendedTruckFunctions.wonderTreeNodeDefaultMaterial)end;self.extendedTruckFunctions.controllerName=self.controllerName end end;function ExtendedTruckFunctions:setLightsTypesMask(C,D,E)for u,p in pairs(self.extendedTruckFunctions.displayNumbers)do if p.node~=nil and p.refNode~=nil and C~=nil then if bitAND(C,1)~=0 then self:replaceMaterialRec(p.node,p.oldMaterial,p.newMaterial)else self:replaceMaterialRec(p.node,p.newMaterial,p.oldMaterial)end end end;if self.timeHud~=nil then local F=g_currentMission.environment.currentMinute;local G=g_currentMission.environment.currentHour;local H=string.format("%02d",F)VehicleHudUtils.setHudValue(self,self.timeHud,tonumber(G.."."..H),9999)end end;function ExtendedTruckFunctions:getIsRainTypeActive()if g_currentMission.environment.currentRain~=nil and g_currentMission.environment.currentRain.rainTypeId~=Environment.RAINTYPE_FOG and g_currentMission.environment.currentRain.rainTypeId~=Environment.RAINTYPE_CLOUDY then local I=g_currentMission.environment:getRainType()local J=false;if I~=nil then if I.rootNode~=nil then J=getVisibility(I.rootNode)end end;return J end;return false end;function ExtendedTruckFunctions:writeStream(K,L)streamWriteBool(K,self.extendedTruckFunctions.rainWipperIsActive)end;function ExtendedTruckFunctions:readStream(K,L)local M=streamReadBool(K)self:setRainWipper(M,true,true)end;function ExtendedTruckFunctions:draw()if self:getIsActiveForInput()and self:getIsRainTypeActive()and self.animations["playRainWipper"]~=nil and self.isMotorStarted then if self.rainWipperIsActive then g_currentMission:addHelpButtonText(g_i18n:getText("STOP_RAIN_WIPPER"),InputBinding.IMPLEMENT_EXTRA2)else g_currentMission:addHelpButtonText(g_i18n:getText("START_RAIN_WIPPER"),InputBinding.IMPLEMENT_EXTRA2)end end end;function ExtendedTruckFunctions:setRainWipper(M,E)if M~=self.extendedTruckFunctions.rainWipperIsActive then self.extendedTruckFunctions.rainWipperIsActive=M;ExtendedTruckFunctionsRainWipperIsActiveEvent.sendEvent(self,M,E)end end;function ExtendedTruckFunctions:getSaveAttributesAndNodes(N)local O='rainWipperIsActive="'..tostring(self.extendedTruckFunctions.rainWipperIsActive)..'"'return O end;function ExtendedTruckFunctions:delete()end;function ExtendedTruckFunctions:mouseEvent(P,Q,R,S,T)end;function ExtendedTruckFunctions:keyEvent(U,V,W,R)end;ExtendedTruckFunctionsRainWipperIsActiveEvent={}ExtendedTruckFunctionsRainWipperIsActiveEvent_mt=Class(ExtendedTruckFunctionsRainWipperIsActiveEvent,Event)InitEventClass(ExtendedTruckFunctionsRainWipperIsActiveEvent,"ExtendedTruckFunctionsRainWipperIsActiveEvent")function ExtendedTruckFunctionsRainWipperIsActiveEvent:emptyNew()local self=Event:new(ExtendedTruckFunctionsRainWipperIsActiveEvent_mt)return self end;function ExtendedTruckFunctionsRainWipperIsActiveEvent:new(X,M)local self=ExtendedTruckFunctionsRainWipperIsActiveEvent:emptyNew()self.truck=X;self.rainWipperIsActive=M;return self end;function ExtendedTruckFunctionsRainWipperIsActiveEvent:readStream(K,L)local Y=streamReadInt32(K)self.truck=networkGetObject(Y)self.rainWipperIsActive=streamReadBool(K)self:run(L)end;function ExtendedTruckFunctionsRainWipperIsActiveEvent:writeStream(K,L)streamWriteInt32(K,networkGetObjectId(self.truck))streamWriteBool(K,self.rainWipperIsActive)end;function ExtendedTruckFunctionsRainWipperIsActiveEvent:run(L)self.truck:setRainWipper(self.rainWipperIsActive,true)if not L:getIsServer()then g_server:broadcastEvent(ExtendedTruckFunctionsRainWipperIsActiveEvent:new(self.truck,self.rainWipperIsActive),nil,L,self.truck)end end;function ExtendedTruckFunctionsRainWipperIsActiveEvent.sendEvent(X,M,E)if E==nil or E==false then if g_server~=nil then g_server:broadcastEvent(ExtendedTruckFunctionsRainWipperIsActiveEvent:new(X,M),nil,nil,X)else g_client:getServerConnection():sendEvent(ExtendedTruckFunctionsRainWipperIsActiveEvent:new(X,M))end end end