--[[
Passangers

Specialization for passengers in MP

Author: 	Ifko[nator]
Date:		08.08.2018
Version:	1.0

History:	V1.0 @08.08.2018 - initial release in FS 17

xml example:

	<passengers>
        <passenger nicknameRenderNode="0>26|0|1">
			<sittingPosition>
				<neck rot="-180 0 -19.014"/>
				<head rot="-180 0 -12.517"/>
			
				<rightHip rot="176.679 -7.223 -176.366"/>
				<rightKnee rot="0 0 -91.605"/>
				<rightFoot rot="0 0 49.493"/>
				<rightShoulder rot="-60.619 2.746 -137.204"/>
				<rightElbow rot="-24.948 6.883 11.843"/>
				<rightHand rot="108.458 -11.513 -13.699"/>
				<rightFingers rot="-1.604 1.276 -10.505"/>
				<rightFingers2 rot="0 0 -7.488"/>
				<rightThumb rot="-94.963 43.775 -34.52"/>
				<rightThumb2 rot="0 0 -6.946"/>
				
				<leftHip rot="177.832 0.187 4.926"/>
				<leftKnee rot="0 0 -91.605"/>
				<leftFoot rot="0 0 49.493"/>
				<leftShoulder rot="-82.433 -7.62 39.478"/>
				<leftElbow rot="-0.92 -2.731 18.596"/>
				<leftHand rot="108.136 -4.695 -11.424"/>
				<leftFingers rot="-1.604 1.276 -10.505"/>
				<leftFingers2 rot="0 0 -7.488"/>
				<leftThumb rot="-94.963 43.775 -34.52"/>
				<leftThumb2 rot="0 0 -6.946"/>
			</sittingPosition>
			
			<male node="0>31|0|0|0|1">
				<neck node="0>31|0|0|0|0|0|0"/>
				<head node="0>31|0|0|0|0|0|0|0"/>
			
				<rightHip node="0>31|0|0|0|0|1"/>
				<rightKnee node="0>31|0|0|0|0|1|0"/>
				<rightFoot node="0>31|0|0|0|0|1|0|0"/>			
				<rightShoulder node="0>31|0|0|0|0|0|0|1"/>
				<rightElbow node="0>31|0|0|0|0|0|0|1|0"/>
				<rightHand node="0>31|0|0|0|0|0|0|1|0|0"/>
				<rightFingers node="0>31|0|0|0|0|0|0|1|0|0|0"/>
				<rightFingers2 node="0>31|0|0|0|0|0|0|1|0|0|0|0"/>
				<rightThumb node="0>31|0|0|0|0|0|0|1|0|0|1"/>
				<rightThumb2 node="0>31|0|0|0|0|0|0|1|0|0|1|0"/>
				
				<leftHip node="0>31|0|0|0|0|2"/>
				<leftKnee node="0>31|0|0|0|0|2|0"/>
				<leftFoot node="0>31|0|0|0|0|2|0|0"/>
				<leftShoulder node="0>31|0|0|0|0|0|0|2"/>
				<leftElbow node="0>31|0|0|0|0|0|0|2|0"/>
				<leftHand node="0>31|0|0|0|0|0|0|2|0|0"/>
				<leftFingers node="0>31|0|0|0|0|0|0|1|0|0|0"/>
				<leftFingers2 node="0>31|0|0|0|0|0|0|1|0|0|0|0"/>
				<leftThumb node="0>31|0|0|0|0|0|0|1|0|0|1"/>
				<leftThumb2 node="0>31|0|0|0|0|0|0|1|0|0|1|0"/>
			</male>
			
			<female node="0>31|0|0|1|1">
				<neck node="0>31|0|0|1|0|0|0"/>
				<head node="0>31|0|0|1|0|0|0|0"/>
				
				<rightHip node="0>31|0|0|1|0|1"/>
				<rightKnee node="0>31|0|0|1|0|1|0"/>
				<rightFoot node="0>31|0|0|1|0|1|0|0"/>
				<rightShoulder node="0>31|0|0|1|0|0|0|1"/>
				<rightElbow node="0>31|0|0|1|0|0|0|1|0"/>
				<rightHand node="0>31|0|0|1|0|0|0|1|0|0"/>
				<rightFingers node="0>31|0|0|1|0|0|0|1|0|0|0"/>
				<rightFingers2 node="0>31|0|0|1|0|0|0|1|0|0|0|0"/>
				<rightThumb node="0>31|0|0|1|0|0|0|1|0|0|1"/>
				<rightThumb2 node="0>31|0|0|1|0|0|0|1|0|0|1|0"/>
				
				<leftHip node="0>31|0|0|1|0|2"/>
				<leftKnee node="0>31|0|0|1|0|2|0"/>
				<leftFoot node="0>31|0|0|1|0|2|0|0"/>
				<leftShoulder node="0>31|0|0|1|0|0|0|2"/>
				<leftElbow node="0>31|0|0|1|0|0|0|2|0"/>
				<leftHand node="0>31|0|0|1|0|0|0|2|0|0"/>
				<leftFingers node="0>31|0|0|1|0|0|0|1|0|0|0"/>
				<leftFingers2 node="0>31|0|0|1|0|0|0|1|0|0|0|0"/>
				<leftThumb node="0>31|0|0|1|0|0|0|1|0|0|1"/>
				<leftThumb2 node="0>31|0|0|1|0|0|0|1|0|0|1|0"/>
			</female>
		
			<camera index="0>26|0|2" rotatable="true" limit="false" transMin="0" transMax="0" useMirror="true" isInside="true" useDefaultPositionSmoothing="false" />
        </passenger>
    </passengers>
]]

Passengers={}function Passengers.prerequisitesPresent(a)return SpecializationUtil.hasSpecialization(Steerable,a)end;function Passengers:load(b)self.setPassenger=SpecializationUtil.callSpecializationsFunction("setPassenger")self.passengers={}local c=0;while true do local d="vehicle.passengers.passenger("..tostring(c)..")"if not hasXMLProperty(self.xmlFile,d)then break end;self.passengers[c]={}self.passengers[c].nicknameRenderNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d.."#nicknameRenderNode"))self.passengers[c].headRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.head#rot"),"-180 0 -19.014"),3)self.passengers[c].neckRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.neck#rot"),"-180 0 -12.517"),3)self.passengers[c].rightHipRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightHip#rot"),"176.679 -7.223 -176.366"),3)self.passengers[c].rightKneeRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightKnee#rot"),"0 0 -91.605"),3)self.passengers[c].rightFootRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightFoot#rot"),"0 0 49.493"),3)self.passengers[c].rightShoulderRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightShoulder#rot"),"-60.619 2.746 -137.204"),3)self.passengers[c].rightElbowRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightElbow#rot"),"-24.948 6.883 11.843"),3)self.passengers[c].rightHandRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightHand#rot"),"108.458 -11.513 -13.699"),3)self.passengers[c].rightFingersRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightFingers#rot"),"-1.604 1.276 -10.505"),3)self.passengers[c].rightFingers2Rot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightFingers2#rot"),"0 0 -7.488"),3)self.passengers[c].rightThumbRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightThumb#rot"),"-94.963 43.775 -34.52"),3)self.passengers[c].rightThumb2Rot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.rightThumb2#rot"),"0 0 -6.946"),3)self.passengers[c].leftHipRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftHip#rot"),"177.832 0.187 4.926"),3)self.passengers[c].leftKneeRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftKnee#rot"),"0 0 -91.605"),3)self.passengers[c].leftFootRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftFoot#rot"),"0 0 49.493"),3)self.passengers[c].leftShoulderRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftShoulder#rot"),"-82.433 -7.62 39.478"),3)self.passengers[c].leftElbowRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftElbow#rot"),"-0.92 -2.731 18.596"),3)self.passengers[c].leftHandRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftHand#rot"),"108.136 -4.695 -11.424"),3)self.passengers[c].leftFingersRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftFingers#rot"),"-1.604 1.276 -10.505"),3)self.passengers[c].leftFingers2Rot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftFingers2#rot"),"0 0 -7.488"),3)self.passengers[c].leftThumbRot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftThumb#rot"),"-94.963 43.775 -34.52"),3)self.passengers[c].leftThumb2Rot=Utils.getVectorNFromString(Utils.getNoNil(getXMLString(self.xmlFile,d..".sittingPosition.leftThumb2#rot"),"0 0 -6.946"),3)self.passengers[c].male=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male#node"))self.passengers[c].head=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".head#node"))self.passengers[c].neck=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".neck#node"))self.passengers[c].maleRightHipNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightHip#node"))self.passengers[c].maleRightKneeNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightKnee#node"))self.passengers[c].maleRightFootNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightFoot#node"))self.passengers[c].maleRightShoulderNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightShoulder#node"))self.passengers[c].maleRightElbowNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightElbow#node"))self.passengers[c].maleRightHandNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightHand#node"))self.passengers[c].maleRightFingersNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightFingers#node"))self.passengers[c].maleRightFingers2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightFingers2#node"))self.passengers[c].maleRightThumbNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightThumb#node"))self.passengers[c].maleRightThumb2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.rightThumb2#node"))self.passengers[c].maleLeftHipNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftHip#node"))self.passengers[c].maleLeftKneeNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftKnee#node"))self.passengers[c].maleLeftFootNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.LeftFoot#node"))self.passengers[c].maleLeftShoulderNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftShoulder#node"))self.passengers[c].maleLeftElbowNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftElbow#node"))self.passengers[c].maleLeftHandNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftHand#node"))self.passengers[c].maleLeftFingersNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftFingers#node"))self.passengers[c].maleLeftFingers2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftFingers2#node"))self.passengers[c].maleLeftThumbNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftThumb#node"))self.passengers[c].maleLeftThumb2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".male.leftThumb2#node"))if self.passengers[c].head~=nil then setRotation(self.passengers[c].head,math.rad(self.passengers[c].headRot[1]),math.rad(self.passengers[c].headRot[2]),math.rad(self.passengers[c].headRot[3]))end;if self.passengers[c].neck~=nil then setRotation(self.passengers[c].neck,math.rad(self.passengers[c].neckRot[1]),math.rad(self.passengers[c].neckRot[2]),math.rad(self.passengers[c].neckRot[3]))end;if self.passengers[c].maleRightHipNode~=nil then setRotation(self.passengers[c].maleRightHipNode,math.rad(self.passengers[c].rightHipRot[1]),math.rad(self.passengers[c].rightHipRot[2]),math.rad(self.passengers[c].rightHipRot[3]))end;if self.passengers[c].maleRightKneeNode~=nil then setRotation(self.passengers[c].maleRightKneeNode,math.rad(self.passengers[c].rightKneeRot[1]),math.rad(self.passengers[c].rightKneeRot[2]),math.rad(self.passengers[c].rightKneeRot[3]))end;if self.passengers[c].maleRightFootNode~=nil then setRotation(self.passengers[c].maleRightFootNode,math.rad(self.passengers[c].rightFootRot[1]),math.rad(self.passengers[c].rightFootRot[2]),math.rad(self.passengers[c].rightFootRot[3]))end;if self.passengers[c].maleRightShoulderNode~=nil then setRotation(self.passengers[c].maleRightShoulderNode,math.rad(self.passengers[c].rightShoulderRot[1]),math.rad(self.passengers[c].rightShoulderRot[2]),math.rad(self.passengers[c].rightShoulderRot[3]))end;if self.passengers[c].maleRightElbowNode~=nil then setRotation(self.passengers[c].maleRightElbowNode,math.rad(self.passengers[c].rightElbowRot[1]),math.rad(self.passengers[c].rightElbowRot[2]),math.rad(self.passengers[c].rightElbowRot[3]))end;if self.passengers[c].maleRightHandNode~=nil then setRotation(self.passengers[c].maleRightHandNode,math.rad(self.passengers[c].rightHandRot[1]),math.rad(self.passengers[c].rightHandRot[2]),math.rad(self.passengers[c].rightHandRot[3]))end;if self.passengers[c].maleRightFingersNode~=nil then setRotation(self.passengers[c].maleRightFingersNode,math.rad(self.passengers[c].rightFingersRot[1]),math.rad(self.passengers[c].rightFingersRot[2]),math.rad(self.passengers[c].rightFingersRot[3]))end;if self.passengers[c].maleRightFingers2Node~=nil then setRotation(self.passengers[c].maleRightFingers2Node,math.rad(self.passengers[c].rightFingers2Rot[1]),math.rad(self.passengers[c].rightFingers2Rot[2]),math.rad(self.passengers[c].rightFingers2Rot[3]))end;if self.passengers[c].maleRightThumbNode~=nil then setRotation(self.passengers[c].maleRightThumbNode,math.rad(self.passengers[c].rightThumbRot[1]),math.rad(self.passengers[c].rightThumbRot[2]),math.rad(self.passengers[c].rightThumbRot[3]))end;if self.passengers[c].maleRightThumb2Node~=nil then setRotation(self.passengers[c].maleRightThumb2Node,math.rad(self.passengers[c].rightThumb2Rot[1]),math.rad(self.passengers[c].rightThumb2Rot[2]),math.rad(self.passengers[c].rightThumb2Rot[3]))end;if self.passengers[c].maleLeftHipNode~=nil then setRotation(self.passengers[c].maleLeftHipNode,math.rad(self.passengers[c].leftHipRot[1]),math.rad(self.passengers[c].leftHipRot[2]),math.rad(self.passengers[c].leftHipRot[3]))end;if self.passengers[c].maleLeftKneeNode~=nil then setRotation(self.passengers[c].maleLeftKneeNode,math.rad(self.passengers[c].leftKneeRot[1]),math.rad(self.passengers[c].leftKneeRot[2]),math.rad(self.passengers[c].leftKneeRot[3]))end;if self.passengers[c].maleLeftFootNode~=nil then setRotation(self.passengers[c].maleLeftFootNode,math.rad(self.passengers[c].leftFootRot[1]),math.rad(self.passengers[c].leftFootRot[2]),math.rad(self.passengers[c].leftFootRot[3]))end;if self.passengers[c].maleLeftShoulderNode~=nil then setRotation(self.passengers[c].maleLeftShoulderNode,math.rad(self.passengers[c].leftShoulderRot[1]),math.rad(self.passengers[c].leftShoulderRot[2]),math.rad(self.passengers[c].leftShoulderRot[3]))end;if self.passengers[c].maleLeftElbowNode~=nil then setRotation(self.passengers[c].maleLeftElbowNode,math.rad(self.passengers[c].leftElbowRot[1]),math.rad(self.passengers[c].leftElbowRot[2]),math.rad(self.passengers[c].leftElbowRot[3]))end;if self.passengers[c].maleLeftHandNode~=nil then setRotation(self.passengers[c].maleLeftHandNode,math.rad(self.passengers[c].leftHandRot[1]),math.rad(self.passengers[c].leftHandRot[2]),math.rad(self.passengers[c].leftHandRot[3]))end;if self.passengers[c].maleLeftFingersNode~=nil then setRotation(self.passengers[c].maleLeftFingersNode,math.rad(self.passengers[c].leftFingersRot[1]),math.rad(self.passengers[c].leftFingersRot[2]),math.rad(self.passengers[c].leftFingersRot[3]))end;if self.passengers[c].maleLeftFingers2Node~=nil then setRotation(self.passengers[c].maleLeftFingers2Node,math.rad(self.passengers[c].leftFingers2Rot[1]),math.rad(self.passengers[c].leftFingers2Rot[2]),math.rad(self.passengers[c].leftFingers2Rot[3]))end;if self.passengers[c].maleLeftThumbNode~=nil then setRotation(self.passengers[c].maleLeftThumbNode,math.rad(self.passengers[c].leftThumbRot[1]),math.rad(self.passengers[c].leftThumbRot[2]),math.rad(self.passengers[c].leftThumbRot[3]))end;if self.passengers[c].maleLeftFingers2Node~=nil then setRotation(self.passengers[c].maleLeftThumb2Node,math.rad(self.passengers[c].leftThumb2Rot[1]),math.rad(self.passengers[c].leftThumb2Rot[2]),math.rad(self.passengers[c].leftThumb2Rot[3]))end;if self.passengers[c].male~=nil then self.passengers[c].maleTestMode=Utils.getNoNil(getXMLBool(self.xmlFile,d..".male#testMode"),false)setVisibility(self.passengers[c].male,self.passengers[c].maleTestMode)end;self.passengers[c].female=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female#node"))self.passengers[c].head=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".head#node"))self.passengers[c].neck=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".neck#node"))self.passengers[c].femaleRightHipNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightHip#node"))self.passengers[c].femaleRightKneeNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightKnee#node"))self.passengers[c].femaleRightFootNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightFoot#node"))self.passengers[c].femaleRightShoulderNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightShoulder#node"))self.passengers[c].femaleRightElbowNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightElbow#node"))self.passengers[c].femaleRightHandNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightHand#node"))self.passengers[c].femaleRightFingersNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightFingers#node"))self.passengers[c].femaleRightFingers2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightFingers2#node"))self.passengers[c].femaleRightThumbNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightThumb#node"))self.passengers[c].femaleRightThumb2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.rightThumb2#node"))self.passengers[c].femaleLeftHipNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftHip#node"))self.passengers[c].femaleLeftKneeNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftKnee#node"))self.passengers[c].femaleLeftFootNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.LeftFoot#node"))self.passengers[c].femaleLeftShoulderNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftShoulder#node"))self.passengers[c].femaleLeftElbowNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftElbow#node"))self.passengers[c].femaleLeftHandNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftHand#node"))self.passengers[c].femaleLeftFingersNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftFingers#node"))self.passengers[c].femaleLeftFingers2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftFingers2#node"))self.passengers[c].femaleLeftThumbNode=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftThumb#node"))self.passengers[c].femaleLeftThumb2Node=Utils.indexToObject(self.components,getXMLString(self.xmlFile,d..".female.leftThumb2#node"))if self.passengers[c].head~=nil then setRotation(self.passengers[c].head,math.rad(self.passengers[c].headRot[1]),math.rad(self.passengers[c].headRot[2]),math.rad(self.passengers[c].headRot[3]))end;if self.passengers[c].neck~=nil then setRotation(self.passengers[c].neck,math.rad(self.passengers[c].neckRot[1]),math.rad(self.passengers[c].neckRot[2]),math.rad(self.passengers[c].neckRot[3]))end;if self.passengers[c].femaleRightHipNode~=nil then setRotation(self.passengers[c].femaleRightHipNode,math.rad(self.passengers[c].rightHipRot[1]),math.rad(self.passengers[c].rightHipRot[2]),math.rad(self.passengers[c].rightHipRot[3]))end;if self.passengers[c].femaleRightKneeNode~=nil then setRotation(self.passengers[c].femaleRightKneeNode,math.rad(self.passengers[c].rightKneeRot[1]),math.rad(self.passengers[c].rightKneeRot[2]),math.rad(self.passengers[c].rightKneeRot[3]))end;if self.passengers[c].femaleRightFootNode~=nil then setRotation(self.passengers[c].femaleRightFootNode,math.rad(self.passengers[c].rightFootRot[1]),math.rad(self.passengers[c].rightFootRot[2]),math.rad(self.passengers[c].rightFootRot[3]))end;if self.passengers[c].femaleRightShoulderNode~=nil then setRotation(self.passengers[c].femaleRightShoulderNode,math.rad(self.passengers[c].rightShoulderRot[1]),math.rad(self.passengers[c].rightShoulderRot[2]),math.rad(self.passengers[c].rightShoulderRot[3]))end;if self.passengers[c].femaleRightElbowNode~=nil then setRotation(self.passengers[c].femaleRightElbowNode,math.rad(self.passengers[c].rightElbowRot[1]),math.rad(self.passengers[c].rightElbowRot[2]),math.rad(self.passengers[c].rightElbowRot[3]))end;if self.passengers[c].femaleRightHandNode~=nil then setRotation(self.passengers[c].femaleRightHandNode,math.rad(self.passengers[c].rightHandRot[1]),math.rad(self.passengers[c].rightHandRot[2]),math.rad(self.passengers[c].rightHandRot[3]))end;if self.passengers[c].femaleRightFingersNode~=nil then setRotation(self.passengers[c].femaleRightFingersNode,math.rad(self.passengers[c].rightFingersRot[1]),math.rad(self.passengers[c].rightFingersRot[2]),math.rad(self.passengers[c].rightFingersRot[3]))end;if self.passengers[c].femaleRightFingers2Node~=nil then setRotation(self.passengers[c].femaleRightFingers2Node,math.rad(self.passengers[c].rightFingers2Rot[1]),math.rad(self.passengers[c].rightFingers2Rot[2]),math.rad(self.passengers[c].rightFingers2Rot[3]))end;if self.passengers[c].femaleRightThumbNode~=nil then setRotation(self.passengers[c].femaleRightThumbNode,math.rad(self.passengers[c].rightThumbRot[1]),math.rad(self.passengers[c].rightThumbRot[2]),math.rad(self.passengers[c].rightThumbRot[3]))end;if self.passengers[c].femaleRightThumb2Node~=nil then setRotation(self.passengers[c].femaleRightThumb2Node,math.rad(self.passengers[c].rightThumb2Rot[1]),math.rad(self.passengers[c].rightThumb2Rot[2]),math.rad(self.passengers[c].rightThumb2Rot[3]))end;if self.passengers[c].femaleLeftHipNode~=nil then setRotation(self.passengers[c].femaleLeftHipNode,math.rad(self.passengers[c].leftHipRot[1]),math.rad(self.passengers[c].leftHipRot[2]),math.rad(self.passengers[c].leftHipRot[3]))end;if self.passengers[c].femaleLeftKneeNode~=nil then setRotation(self.passengers[c].femaleLeftKneeNode,math.rad(self.passengers[c].leftKneeRot[1]),math.rad(self.passengers[c].leftKneeRot[2]),math.rad(self.passengers[c].leftKneeRot[3]))end;if self.passengers[c].femaleLeftFootNode~=nil then setRotation(self.passengers[c].femaleLeftFootNode,math.rad(self.passengers[c].leftFootRot[1]),math.rad(self.passengers[c].leftFootRot[2]),math.rad(self.passengers[c].leftFootRot[3]))end;if self.passengers[c].femaleLeftShoulderNode~=nil then setRotation(self.passengers[c].femaleLeftShoulderNode,math.rad(self.passengers[c].leftShoulderRot[1]),math.rad(self.passengers[c].leftShoulderRot[2]),math.rad(self.passengers[c].leftShoulderRot[3]))end;if self.passengers[c].femaleLeftElbowNode~=nil then setRotation(self.passengers[c].femaleLeftElbowNode,math.rad(self.passengers[c].leftElbowRot[1]),math.rad(self.passengers[c].leftElbowRot[2]),math.rad(self.passengers[c].leftElbowRot[3]))end;if self.passengers[c].femaleLeftHandNode~=nil then setRotation(self.passengers[c].femaleLeftHandNode,math.rad(self.passengers[c].leftHandRot[1]),math.rad(self.passengers[c].leftHandRot[2]),math.rad(self.passengers[c].leftHandRot[3]))end;if self.passengers[c].femaleLeftFingersNode~=nil then setRotation(self.passengers[c].femaleLeftFingersNode,math.rad(self.passengers[c].leftFingersRot[1]),math.rad(self.passengers[c].leftFingersRot[2]),math.rad(self.passengers[c].leftFingersRot[3]))end;if self.passengers[c].femaleLeftFingers2Node~=nil then setRotation(self.passengers[c].femaleLeftFingers2Node,math.rad(self.passengers[c].leftFingers2Rot[1]),math.rad(self.passengers[c].leftFingers2Rot[2]),math.rad(self.passengers[c].leftFingers2Rot[3]))end;if self.passengers[c].femaleLeftThumbNode~=nil then setRotation(self.passengers[c].femaleLeftThumbNode,math.rad(self.passengers[c].leftThumbRot[1]),math.rad(self.passengers[c].leftThumbRot[2]),math.rad(self.passengers[c].leftThumbRot[3]))end;if self.passengers[c].femaleLeftFingers2Node~=nil then setRotation(self.passengers[c].femaleLeftThumb2Node,math.rad(self.passengers[c].leftThumb2Rot[1]),math.rad(self.passengers[c].leftThumb2Rot[2]),math.rad(self.passengers[c].leftThumb2Rot[3]))end;if self.passengers[c].female~=nil then self.passengers[c].femaleTestMode=Utils.getNoNil(getXMLBool(self.xmlFile,d..".female#testMode"),false)setVisibility(self.passengers[c].female,self.passengers[c].femaleTestMode)end;self.passengers[c].renderNodeOffset={0,0,0}self.passengers[c].currentPlayer=nil;self.passengers[c].currentName=""self.passengers[c].camera={}local e=string.format(d..".camera")local f=VehicleCamera:new(self)if f:loadFromXML(self.xmlFile,e)then table.insert(self.passengers[c].camera,f)end;c=c+1 end;self.oldCamX=0;self.oldCamY=0;self.inRangeOfVehicle=false end;function Passengers:delete()local g=false;for h,i in pairs(self.passengers)do if i.currentPlayer~=nil then if not i.currentPlayer.isControlled and not i.currentPlayer.isEntered and not(i.currentName==g_currentMission.player.controllerName)then if i.currentPlayer==g_currentMission.player then g_currentMission.isPlayerFrozen=false end;self:setPassenger(h,"ExitedToOtherVehicle",nil,true)end;if i.currentName==g_currentMission.player.controllerName then g_currentMission.hasSpecialCamera=false;i.camera[1]:onDeactivate()g_currentMission.hasSpecialCamera=false;setCamera(i.currentPlayer.cameraId)g_currentMission.hasSpecialCamera=false;g_currentMission.isPlayerFrozen=false end;self:setPassenger(h,"Exited",nil,true)end;for j,f in pairs(i.camera)do f:delete()end end end;function Passengers:readStream(k,l)for j,i in pairs(self.passengers)do local m=streamReadInt32(k)i.currentName=streamReadString(k)if m~=-1 then i.currentPlayer=networkGetObject(m)end end end;function Passengers:writeStream(k,l)for j,i in pairs(self.passengers)do if i.currentPlayer~=nil then streamWriteInt32(k,networkGetObjectId(i.currentPlayer))else streamWriteInt32(k,-1)end;streamWriteString(k,i.currentName)end end;function Passengers:update(n)local g=false;for c,i in pairs(self.passengers)do if i.currentPlayer~=nil then if not i.currentPlayer.isControlled and not i.currentPlayer.isEntered then if i.currentPlayer==g_currentMission.player then g_currentMission.isPlayerFrozen=false end;self:setPassenger(c,"ExitedToOtherVehicle",nil)return end end;if self.inRangeOfVehicle and i.currentPlayer==nil and self.isControlled and g_currentMission.player.controllerName~=self.controllerName then if not g then g=true;g_currentMission:addHelpButtonText(g_i18n:getText("PASSENGER_ENTER"),InputBinding.ENTER)end;if InputBinding.hasEvent(InputBinding.ENTER)then local o,p,q=getWorldTranslation(i.male)local r,s,t=getWorldTranslation(g_currentMission.player.rootNode)local u=Utils.vector3Length(o-r,p-s,q-t)local v=u;local w=c;local x=i;for y,z in pairs(self.passengers)do if z.currentPlayer==nil then o,p,q=getWorldTranslation(z.male)r,s,t=getWorldTranslation(g_currentMission.player.rootNode)u=Utils.vector3Length(o-r,p-s,q-t)if v>u then w=y;v=u;x=z end end end;self:setPassenger(w,g_currentMission.player.controllerName,g_currentMission.player)g_currentMission.hasSpecialCamera=true;x.camera[1]:onActivate()g_currentMission.hasSpecialCamera=true;return end end;if i.currentPlayer~=nil then if g_currentMission:getIsServer()then if g_currentMission.connectionsToPlayer[i.currentPlayer.creatorConnection]==nil then self:setPassenger(c,"Disconnected",nil)return end end;if i.currentName==g_currentMission.player.controllerName then i.camera[1]:update(n)g_currentMission:addHelpButtonText(g_i18n:getText("PASSENGER_EXIT"),InputBinding.ENTER)if InputBinding.hasEvent(InputBinding.ENTER)and g_gui.currentGui==nil and g_gui.currentGuiName~="ChatDialog"then g_currentMission.hasSpecialCamera=false;i.camera[1]:onDeactivate()g_currentMission.hasSpecialCamera=false;if i.currentPlayer.cameraId~=nil then setCamera(i.currentPlayer.cameraId)end;g_currentMission.hasSpecialCamera=false;g_currentMission.isPlayerFrozen=false;self:setPassenger(c,"Exited",nil)end;local A=Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT)or Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT)or Input.isMouseButtonPressed(Input.MOUSE_BUTTON_MIDDLE)if i.camera[1].isRotatable and not A then local B=InputBinding.mouseMovementY*2*g_gameSettings:getValue("cameraSensitivity")if self.oldCamY~=B or self.oldCamX~=InputBinding.mouseMovementX then if g_gameSettings:getValue("invertYLook")then B=-B end;if i.camera[1].limitRotXDelta>0.001 then i.camera[1].rotX=math.min(i.camera[1].rotX+B,i.camera[1].rotX)elseif i.camera[1].limitRotXDelta<-0.001 then i.camera[1].rotX=math.max(i.camera[1].rotX+B,i.camera[1].rotX)else i.camera[1].rotX=i.camera[1].rotX+B end;i.camera[1].rotY=i.camera[1].rotY-InputBinding.mouseMovementX*2*g_gameSettings:getValue("cameraSensitivity")i.camera[1]:updateRotateNodeRotation()self.oldCamY=B;self.oldCamX=InputBinding.mouseMovementX end end end end end;for j,i in pairs(self.passengers)do if g_currentMission.player.controllerName~=nil and i.currentName~=g_currentMission.player.controllerName and i.currentPlayer~=nil and g_gui.currentGui==nil then local C,D,E=getWorldTranslation(i.nicknameRenderNode)local F,G,H=getWorldTranslation(getCamera())local I=Utils.vector3LengthSq(C-F,D-G,E-H)local J=I<=100*100;if J then Utils.renderTextAtWorldPosition(C,D,E,i.currentName,getCorrectTextSize(0.02),0)end end end end;function Passengers:updateTick(n)if g_currentMission.player~=nil then local v=4.0;local o,p,q=getWorldTranslation(self.rootNode)local r,s,t=getWorldTranslation(g_currentMission.player.rootNode)local u=Utils.vector3Length(o-r,p-s,q-t)if u<v then self.inRangeOfVehicle=true else self.inRangeOfVehicle=false end end end;function Passengers:setPassenger(c,K,L,M)SetPassengerEvent.sendEvent(self,c,K,L,M)if L~=nil then local C,D,E=getWorldTranslation(self.passengers[c].male)L:moveToAbsolute(C,D-500,E)setTranslation(L.rootNode,C,D-500,E)if L==g_currentMission.player then g_currentMission.isPlayerFrozen=true else local N="male"if string.find(L.walkClipName,"female")then N="female"end;setVisibility(self.passengers[c].male,N=="male")setVisibility(self.passengers[c].female,N=="female")local O,P,Q,R=unpack(g_availableMpColorsTable[L.playerColorIndex].value)setShaderParameter(self.passengers[c].male,"colorScaleR",O,P,Q,R,false)setShaderParameter(self.passengers[c].female,"colorScaleR",O,P,Q,R,false)end;self.passengers[c].currentName=K elseif K=="Exited"then if self.passengers[c].currentPlayer~=nil then self.passengers[c].currentPlayer:moveToExitPoint(self)end;setVisibility(self.passengers[c].male,false)setVisibility(self.passengers[c].female,false)self.passengers[c].currentName=""else setVisibility(self.passengers[c].male,false)setVisibility(self.passengers[c].female,false)self.passengers[c].currentName=""end;self.passengers[c].currentPlayer=L end;function Passengers:mouseEvent(S,T,U,V,W)end;function Passengers:keyEvent(X,Y,Z,U)end;function Passengers:draw()end;SetPassengerEvent={}SetPassengerEvent_mt=Class(SetPassengerEvent,Event)InitEventClass(SetPassengerEvent,"SetPassengerEvent")function SetPassengerEvent:emptyNew()local self=Event:new(SetPassengerEvent_mt)self.className="SetPassengerEvent"return self end;function SetPassengerEvent:new(_,c,K,L)local self=SetPassengerEvent:emptyNew()self.passengerNumber=c;self.vehicle=_;self.passengerName=K;self.passengerPlayer=L;return self end;function SetPassengerEvent:readStream(k,l)local c=streamReadInt32(k)self.vehicle=networkGetObject(c)self.passengerNumber=streamReadInt32(k)local a0=streamReadBool(k)if a0 then local m=streamReadInt32(k)self.passengerPlayer=networkGetObject(m)else self.passengerPlayer=nil end;self.passengerName=streamReadString(k)self:run(l)end;function SetPassengerEvent:writeStream(k,l)streamWriteInt32(k,networkGetObjectId(self.vehicle))streamWriteInt32(k,self.passengerNumber)streamWriteBool(k,self.passengerPlayer~=nil)if self.passengerPlayer~=nil then streamWriteInt32(k,networkGetObjectId(self.passengerPlayer))end;streamWriteString(k,self.passengerName)end;function SetPassengerEvent:run(l)self.vehicle:setPassenger(self.passengerNumber,self.passengerName,self.passengerPlayer,true)if not l:getIsServer()then g_server:broadcastEvent(SetPassengerEvent:new(self.vehicle,self.passengerNumber,self.passengerName,self.passengerPlayer),nil,l,self.vehicle)end end;function SetPassengerEvent.sendEvent(_,c,K,L,M)if M==nil or M==false then if g_server~=nil then g_server:broadcastEvent(SetPassengerEvent:new(_,c,K,L),nil,nil,_)else g_client:getServerConnection():sendEvent(SetPassengerEvent:new(_,c,K,L))end end end